Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# BallSymbols Class Reference

The Xabsl2 symbols that are defined in "ball-symbols.xml". More...

`#include <BallSymbols.h>`

Inheritance diagram for BallSymbols:

[legend]
Collaboration diagram for BallSymbols:

[legend]
List of all members.

## Public Member Functions
| BallSymbols (const BehaviorControlInterfaces &interfaces)
void | registerSymbols (Xabsl2Engine &engine)
| registers the symbols at an engine
void | update ()
| updates the symbols
Input symbols
double | getNumberOfImagesWithBallPercept ()
double | getNumberOfImagesWithoutBallPercept ()
double | getSeenDistance ()
double | getSeenAngle ()
double | getSeenSpeed ()
double | getSeenRelativeSpeedX ()
double | getSeenRelativeSpeedY ()
double | getSeenDistanceX ()
double | getSeenDistanceY ()
double | getProjectedDistanceOnYAxis ()
double | getTimeUntilBallCrossesYAxis ()
double | getDistanceSeenBallToOwnPenaltyArea ()
double | getTimeSinceLastSeen ()
double | getConsecutivelySeenTime ()
double | getTimeSinceLastSeenConsecutively ()
bool | getBallSeenInFrontOfOpponentGoal ()
bool | getJustSeen ()
double | getKnownDistance ()
double | getKnownAngle ()
double | getKnownX ()
double | getKnownY ()
double | getHypotheticalDistance ()
double | getHypotheticalAngle ()
double | getTimeSinceLastKnown ()
double | getTimeAfterWhichCommunicatedBallAreAccepted ()
double | getPositionValidity ()
double | getSpeedValidity ()
double | getAngleToOpponentGoal ()
double | getSeenDistanceToBorder ()
double | getSeenPositionValidity ()
double | getSeenVelocityValidity ()
double | getPropagatedPositionValidity ()
double | getPropagatedVelocityValidity ()
double | getPropagatedDistance ()
double | getPropagatedAngle ()
double | getPropagatedX ()
double | getPropagatedY ()
double | getPropagatedRelativeX ()
double | getPropagatedRelativeY ()
double | getTimeAfterWhichPropagatedAreUsed ()
double | getMaxDistanceToUseSeen ()
double | getPropagatedSpeedX ()
double | getPropagatedSpeedY ()
double | getPropagatedRelativeSpeedX ()
double | getPropagatedRelativeSpeedY ()
double | getSeenSpeedX ()
double | getSeenSpeedY ()
double | getKnownOrNearDistance ()
double | getKnownOrNearX ()
double | getKnownOrNearY ()
double | getKnownOrNearRelativeX ()
double | getKnownOrNearRelativeY ()
double | getKnownOrNearSpeedX ()
double | getKnownOrNearSpeedY ()
double | getKnownOrNearSpeedAbs ()
double | getKnownOrNearProbability ()
double | getKnownOrNearRelativeSpeedX ()
double | getKnownOrNearRelativeSpeedY ()
double | getKnownOrNearAngle ()
double | getSeenRelativeX ()
double | getSeenRelativeY ()
double | getKnownOrNearAngleToOwnGoal ()
double | getKnownOrNearDistanceToOwnPenaltyArea ()
double | getBallInterceptionPointX ()
double | getBallInterceptionPointY ()
bool | getBallCanBeIntercepted ()
## Public Attributes
double | averageDistance
| The average distane to the ball.
## Private Member Functions
void | calculateInterceptionPoint ()
## Private Attributes
RingBufferWithSum< 60 > | ballDistanceRingBuffer
| A ring buffer needed to calculate the average ball distance.
bool | playBallPrecisely
int | ballPrecision
bool | ballCanBeIntercepted
bool | interceptionAlreadyCalculated
Vector2< double > | interceptionPoint

## Detailed Description

The Xabsl2 symbols that are defined in "ball-symbols.xml".

Author:
  Martin Lötzsch

Definition at line 21 of file BallSymbols.h.

## Constructor & Destructor Documentation

BallSymbols::BallSymbols | ( | const BehaviorControlInterfaces & | interfaces | ) |

| Definition at line 14 of file BallSymbols.cpp.

## Member Function Documentation

void BallSymbols::registerSymbols | ( | Xabsl2Engine & | engine | ) |

| registers the symbols at an engine Definition at line 22 of file BallSymbols.cpp. References averageDistance, ballPrecision, BallState::ballRollsByLeft, BallState::ballRollsByRight, BallState::ballRollsFarByLeft, BallState::ballRollsFarByRight, BallState::ballRollsFast, BallState::ballRollsTowardsRobot, BallModel::ballWasSeen, getAngleToOpponentGoal(), getBallCanBeIntercepted(), getBallInterceptionPointX(), getBallInterceptionPointY(), getBallSeenInFrontOfOpponentGoal(), getConsecutivelySeenTime(), getDistanceSeenBallToOwnPenaltyArea(), getHypotheticalAngle(), getHypotheticalDistance(), getJustSeen(), getKnownAngle(), getKnownDistance(), getKnownOrNearAngle(), getKnownOrNearAngleToOwnGoal(), getKnownOrNearDistance(), getKnownOrNearDistanceToOwnPenaltyArea(), getKnownOrNearProbability(), getKnownOrNearRelativeSpeedX(), getKnownOrNearRelativeSpeedY(), getKnownOrNearRelativeX(), getKnownOrNearRelativeY(), getKnownOrNearSpeedAbs(), getKnownOrNearSpeedX(), getKnownOrNearX(), getKnownOrNearY(), getKnownX(), getKnownY(), getMaxDistanceToUseSeen(), getNumberOfImagesWithBallPercept(), getNumberOfImagesWithoutBallPercept(), getPositionValidity(), getProjectedDistanceOnYAxis(), getPropagatedAngle(), getPropagatedDistance(), getPropagatedPositionValidity(), getPropagatedRelativeSpeedX(), getPropagatedRelativeSpeedY(), getPropagatedRelativeX(), getPropagatedRelativeY(), getPropagatedSpeedX(), getPropagatedSpeedY(), getPropagatedVelocityValidity(), getPropagatedX(), getPropagatedY(), getSeenAngle(), getSeenDistance(), getSeenDistanceToBorder(), getSeenDistanceX(), getSeenDistanceY(), getSeenPositionValidity(), getSeenRelativeSpeedX(), getSeenRelativeSpeedY(), getSeenRelativeX(), getSeenRelativeY(), getSeenSpeed(), getSeenSpeedX(), getSeenSpeedY(), getSeenVelocityValidity(), getSpeedValidity(), getTimeAfterWhichCommunicatedBallAreAccepted(), getTimeAfterWhichPropagatedAreUsed(), getTimeSinceLastKnown(), getTimeSinceLastSeen(), getTimeSinceLastSeenConsecutively(), getTimeUntilBallCrossesYAxis(), BallModel::hypothetical, playBallPrecisely, BallState::positionField, regBoolFct, regBoolSym, regDoubleFct, regDoubleSym, regEnumOutSymbol, regEnumOutSymbolElement, BallModel::seen, Vector2< double >::x, and Vector2< double >::y. Referenced by GT2005BehaviorControl::registerSymbolsAndBasicBehaviors().

Here is the call graph for this function:

void BallSymbols::update | ( |  | ) |

| updates the symbols Definition at line 136 of file BallSymbols.cpp. References RingBufferWithSum< 60 >::add(), averageDistance, ballCanBeIntercepted, ballDistanceRingBuffer, ballPrecision, RingBufferWithSum< 60 >::getNumberOfEntries(), RobotPose::getPose(), RingBufferWithSum< 60 >::getSum(), interceptionAlreadyCalculated, NCIRCLE, NDECLARE_DEBUGDRAWING, playBallPrecisely, BallState::positionField, BallModel::seen, Pose2D::translation, Vector2< double >::x, and Vector2< double >::y. Referenced by GT2005BehaviorControl::execute().

Here is the call graph for this function:

double BallSymbols::getNumberOfImagesWithBallPercept | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 310 of file BallSymbols.cpp. References BallModel::numberOfImagesWithBallPercept. Referenced by registerSymbols().

double BallSymbols::getNumberOfImagesWithoutBallPercept | ( |  | ) |

| A function for the symbol "ball.number-of-images-without-ball-percept" Definition at line 315 of file BallSymbols.cpp. References BallModel::numberOfImagesWithoutBallPercept. Referenced by registerSymbols().

double BallSymbols::getSeenDistance | ( |  | ) |

| A function for the symbol "ball.seen.distance" Definition at line 166 of file BallSymbols.cpp. References Vector2< double >::abs(), BallState::positionRobot, and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenAngle | ( |  | ) |

| A function for the symbol "ball.seen.angle" Definition at line 194 of file BallSymbols.cpp. References RobotPose::getPose(), BallState::positionField, BallModel::seen, and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenSpeed | ( |  | ) |

| A function for the symbol "ball.seen.speed" Definition at line 200 of file BallSymbols.cpp. References Vector2< double >::abs(), BallModel::seen, and BallState::speedField. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenRelativeSpeedX | ( |  | ) |

| A function for the symbol "ball.seen.relative-speed.x" Definition at line 205 of file BallSymbols.cpp. References BallModel::seen, BallState::speedRobot, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getSeenRelativeSpeedY | ( |  | ) |

| A function for the symbol "ball.seen.relative-speed.y" Definition at line 210 of file BallSymbols.cpp. References BallModel::seen, BallState::speedRobot, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getSeenDistanceX | ( |  | ) |

| A function for the symbol "ball.seen.distance-x" Definition at line 171 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::seen, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getSeenDistanceY | ( |  | ) |

| A function for the symbol "ball.seen.distance-y" Definition at line 176 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::seen, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getProjectedDistanceOnYAxis | ( |  | ) |

| A function for the symbol "ball.projectedDistanceOnYAxis" Definition at line 225 of file BallSymbols.cpp. References BallState::projectedDistanceOnYAxis, and BallModel::seen. Referenced by registerSymbols().

double BallSymbols::getTimeUntilBallCrossesYAxis | ( |  | ) |

| A function for the symbol "ball.timeBallCrossesYAxis" Definition at line 220 of file BallSymbols.cpp. References BallModel::seen, and BallState::timeTillBallCrossesYAxis. Referenced by registerSymbols().

double BallSymbols::getDistanceSeenBallToOwnPenaltyArea | ( |  | ) |

| A function for the symbol "ball.seen.distance-to-own-penalty-area" Definition at line 215 of file BallSymbols.cpp. References FieldDimensions::distanceToOwnPenaltyArea(), BallState::positionField, and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getTimeSinceLastSeen | ( |  | ) |

| A function for the symbol "ball.time-since-last-seen" Definition at line 269 of file BallSymbols.cpp. References SystemCall::getTimeSince(), BallModel::seen, and SeenBallState::timeWhenLastSeen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getConsecutivelySeenTime | ( |  | ) |

| A function for the symbol "ball.consecutively-seen-time" Definition at line 274 of file BallSymbols.cpp. References BallModel::seen, SeenBallState::timeUntilSeenConsecutively, and SeenBallState::timeWhenFirstSeenConsecutively. Referenced by registerSymbols().

double BallSymbols::getTimeSinceLastSeenConsecutively | ( |  | ) |

| A function for the symbol "ball.time-since-last-seen-consecutively" Definition at line 280 of file BallSymbols.cpp. References SystemCall::getTimeSince(), BallModel::seen, and SeenBallState::timeUntilSeenConsecutively. Referenced by registerSymbols().

Here is the call graph for this function:

bool BallSymbols::getBallSeenInFrontOfOpponentGoal | ( |  | ) |

| A function for the symbol "ball.seen.ball-in-front-of-opponent-goal Definition at line 285 of file BallSymbols.cpp. References BallState::ballInFrontOfOpponentGoal, and BallModel::getKnownBallState(). Referenced by registerSymbols().

Here is the call graph for this function:

bool BallSymbols::getJustSeen | ( |  | ) |

| A function for the symbol "ball.just-seen" Definition at line 290 of file BallSymbols.cpp. References SystemCall::getTimeSince(), BallModel::seen, and SeenBallState::timeWhenLastSeen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownDistance | ( |  | ) |

| A function for the symbol "ball.known.distance" Definition at line 161 of file BallSymbols.cpp. References Vector2< double >::abs(), BallModel::getKnownBallState(), and BallState::positionRobot. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownAngle | ( |  | ) |

| A function for the symbol "ball.known.angle" Definition at line 181 of file BallSymbols.cpp. References BallModel::getKnownPosition(), RobotPose::getPose(), and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownX | ( |  | ) |

| A function for the symbol "ball.known.x" Definition at line 230 of file BallSymbols.cpp. References BallModel::getKnownPosition(), and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownY | ( |  | ) |

| A function for the symbol "ball.known.y" Definition at line 236 of file BallSymbols.cpp. References BallModel::getKnownPosition(), and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getHypotheticalDistance | ( |  | ) |

| A function for the symbol "ball.hypothetical.distance" Definition at line 242 of file BallSymbols.cpp. References Vector2< double >::abs(), BallModel::hypothetical, and BallState::positionRobot. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getHypotheticalAngle | ( |  | ) |

| A function for the symbol "ball.hypothetical.angle" Definition at line 247 of file BallSymbols.cpp. References RobotPose::getPose(), BallModel::hypothetical, BallState::positionField, Pose2D::rotation, and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getTimeSinceLastKnown | ( |  | ) |

| A function for the symbol "ball.time-since-last-known" Definition at line 263 of file BallSymbols.cpp. References BallModel::getTimeSinceLastKnown(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getTimeAfterWhichCommunicatedBallAreAccepted | ( |  | ) |

| A function for the symbol "ball.time-after-which-communicated-balls-are-accepted" Definition at line 189 of file BallSymbols.cpp. Referenced by registerSymbols().

double BallSymbols::getPositionValidity | ( |  | ) |

| A function for the symbol "ball.seen.positionValidity" Definition at line 253 of file BallSymbols.cpp. References BallState::getPositionValidity(), and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSpeedValidity | ( |  | ) |

| A function for the symbol "ball.seen.speedValidity" Definition at line 258 of file BallSymbols.cpp. References BallState::getSpeedValidity(), and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getAngleToOpponentGoal | ( |  | ) |

| calculates the value for the symbol "ball.angle-to-opponent-goal" Definition at line 295 of file BallSymbols.cpp. References BallModel::getKnownBallState(), normalize(), BallState::positionField, and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenDistanceToBorder | ( |  | ) |

| calculates the value for the symbol "ball.seen.distance-to-border" Definition at line 305 of file BallSymbols.cpp. References FieldDimensions::distanceToBorder(), BallState::positionField, and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenPositionValidity | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 320 of file BallSymbols.cpp. References BallState::positionProb, and BallModel::seen. Referenced by registerSymbols().

double BallSymbols::getSeenVelocityValidity | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 326 of file BallSymbols.cpp. References BallModel::seen, and BallState::velocityProb. Referenced by registerSymbols().

double BallSymbols::getPropagatedPositionValidity | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 332 of file BallSymbols.cpp. References BallState::positionProb, and BallModel::propagated. Referenced by registerSymbols().

double BallSymbols::getPropagatedVelocityValidity | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 337 of file BallSymbols.cpp. References BallModel::propagated, and BallState::velocityProb. Referenced by registerSymbols().

double BallSymbols::getPropagatedDistance | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 348 of file BallSymbols.cpp. References Vector2< double >::abs(), BallState::positionRobot, and BallModel::propagated. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getPropagatedAngle | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 342 of file BallSymbols.cpp. References RobotPose::getPose(), BallState::positionField, BallModel::propagated, and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getPropagatedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 353 of file BallSymbols.cpp. References BallState::positionField, BallModel::propagated, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getPropagatedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 358 of file BallSymbols.cpp. References BallState::positionField, BallModel::propagated, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getPropagatedRelativeX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 383 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::propagated, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getPropagatedRelativeY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 388 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::propagated, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getTimeAfterWhichPropagatedAreUsed | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 363 of file BallSymbols.cpp. Referenced by registerSymbols().

double BallSymbols::getMaxDistanceToUseSeen | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 368 of file BallSymbols.cpp. Referenced by registerSymbols().

double BallSymbols::getPropagatedSpeedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 373 of file BallSymbols.cpp. References BallModel::propagated, BallState::speedField, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getPropagatedSpeedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 378 of file BallSymbols.cpp. References BallModel::propagated, BallState::speedField, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getPropagatedRelativeSpeedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 393 of file BallSymbols.cpp. References BallModel::propagated, BallState::speedRobot, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getPropagatedRelativeSpeedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 398 of file BallSymbols.cpp. References BallModel::propagated, BallState::speedRobot, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getSeenSpeedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 403 of file BallSymbols.cpp. References BallModel::seen, BallState::speedField, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getSeenSpeedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 409 of file BallSymbols.cpp. References BallModel::seen, BallState::speedField, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getKnownOrNearDistance | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 415 of file BallSymbols.cpp. References Vector2< double >::abs(), BallModel::getKnownBallState(), and BallState::positionRobot. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 436 of file BallSymbols.cpp. References BallModel::getKnownPosition(), and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 454 of file BallSymbols.cpp. References BallModel::getKnownPosition(), and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearRelativeX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 463 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::positionRobot, and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearRelativeY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 472 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::positionRobot, and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearSpeedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 481 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::speedField, and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearSpeedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 486 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::speedField, and Vector2< double >::y.

Here is the call graph for this function:

double BallSymbols::getKnownOrNearSpeedAbs | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 501 of file BallSymbols.cpp. References Vector2< V >::abs(), BallModel::getKnownBallState(), BallState::speedField, Vector2< double >::x, and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearProbability | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 445 of file BallSymbols.cpp. References BallModel::getKnownBallState(), and BallState::positionProb. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearRelativeSpeedX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 491 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::speedRobot, and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearRelativeSpeedY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 496 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::speedRobot, and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearAngle | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 425 of file BallSymbols.cpp. References BallModel::getKnownPosition(), RobotPose::getPose(), and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getSeenRelativeX | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 508 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::seen, and Vector2< double >::x. Referenced by registerSymbols().

double BallSymbols::getSeenRelativeY | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 514 of file BallSymbols.cpp. References BallState::positionRobot, BallModel::seen, and Vector2< double >::y. Referenced by registerSymbols().

double BallSymbols::getKnownOrNearAngleToOwnGoal | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 520 of file BallSymbols.cpp. References BallModel::getKnownBallState(), BallState::positionField, and toDegrees(). Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getKnownOrNearDistanceToOwnPenaltyArea | ( |  | ) |

| A function for the symbol "ball.number-of-images-with-ball-percept" Definition at line 526 of file BallSymbols.cpp. References FieldDimensions::distanceToOwnPenaltyArea(), BallModel::getKnownBallState(), and BallState::positionField. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getBallInterceptionPointX | ( |  | ) |

| A function for the symbol "ball.interceptionPoint.x" Definition at line 531 of file BallSymbols.cpp. References calculateInterceptionPoint(), interceptionAlreadyCalculated, interceptionPoint, and Vector2< double >::x. Referenced by registerSymbols().

Here is the call graph for this function:

double BallSymbols::getBallInterceptionPointY | ( |  | ) |

| A function for the symbol "ball.interceptionPoint.x" Definition at line 540 of file BallSymbols.cpp. References calculateInterceptionPoint(), interceptionAlreadyCalculated, interceptionPoint, and Vector2< double >::y. Referenced by registerSymbols().

Here is the call graph for this function:

bool BallSymbols::getBallCanBeIntercepted | ( |  | ) |

| A function for the symbol "ball.ballCanBeIntercepted" Definition at line 549 of file BallSymbols.cpp. References ballCanBeIntercepted, calculateInterceptionPoint(), and interceptionAlreadyCalculated. Referenced by registerSymbols().

Here is the call graph for this function:

void BallSymbols::calculateInterceptionPoint | ( |  | ) | `[private]`

| Definition at line 558 of file BallSymbols.cpp. References ballCanBeIntercepted, BallModel::getKnownBallState(), interceptionAlreadyCalculated, interceptionPoint, min, BallState::positionRobot, BallState::speedRobot, sqr, Vector2< double >::x, Vector2< V >::x, Vector2< double >::y, and Vector2< V >::y. Referenced by getBallCanBeIntercepted(), getBallInterceptionPointX(), and getBallInterceptionPointY().

Here is the call graph for this function:

## Member Data Documentation

double BallSymbols::averageDistance

| The average distane to the ball. Definition at line 108 of file BallSymbols.h. Referenced by registerSymbols(), and update().

RingBufferWithSum<60> BallSymbols::ballDistanceRingBuffer`[private]`

| A ring buffer needed to calculate the average ball distance. Definition at line 112 of file BallSymbols.h. Referenced by update().

bool BallSymbols::playBallPrecisely`[private]`

| Definition at line 114 of file BallSymbols.h. Referenced by registerSymbols(), and update().

int BallSymbols::ballPrecision`[private]`

| Definition at line 116 of file BallSymbols.h. Referenced by registerSymbols(), and update().

bool BallSymbols::ballCanBeIntercepted`[private]`

| Definition at line 119 of file BallSymbols.h. Referenced by calculateInterceptionPoint(), getBallCanBeIntercepted(), and update().

bool BallSymbols::interceptionAlreadyCalculated`[private]`

| Definition at line 120 of file BallSymbols.h. Referenced by calculateInterceptionPoint(), getBallCanBeIntercepted(), getBallInterceptionPointX(), getBallInterceptionPointY(), and update().

Vector2<double> BallSymbols::interceptionPoint`[private]`

| Definition at line 121 of file BallSymbols.h. Referenced by calculateInterceptionPoint(), getBallInterceptionPointX(), and getBallInterceptionPointY().

The documentation for this class was generated from the following files:

- Modules/BehaviorControl/CommonXabsl2Symbols/BallSymbols.h
- Modules/BehaviorControl/CommonXabsl2Symbols/BallSymbols.cpp